Attribute VB_Name = "Sprite"
Option Explicit
Type point
    x As Integer
    y As Integer
End Type

Type sprite
    lives As Integer
    state As Integer
    radius As Long
    position As point
    startspeed As point
    speed As point
    onfloor As Boolean
    picsource As StdPicture
    hsourceDC As Long
    picmask As StdPicture
    hmaskDc As Long
    CellTop As Integer
    CellWidth As Integer
    CellHeight As Integer
    CellCount As Integer
 
End Type
Public bgticker As Integer
Public Const bgmax = 10
Public Enemy(0 To bgmax) As sprite
Public mario As sprite
Public bgnumber As Integer
Public Const Normal = 0
Public Const Flipped = 1
Public Const Dying = 2
Public Const Waiting = 4
Public Const Dead = 3
Dim EnemyAlive As Integer
Public TempBgSpeed As Integer
Const gravity = 3


Public Sub mariomove()
    getspeed mario
    If mario.position.x > backdrop.Rightside Then
        mario.position.x = backdrop.Leftside
    Else
        If mario.position.x < backdrop.Leftside Then
            mario.position.x = backdrop.Rightside
        Else
            mario.position.x = mario.position.x + mario.speed.x
        End If
    End If
    
    mario.position.y = mario.position.y + mario.speed.y
If mario.position.y > 480 Then
   mario.state = Dead
   mario.position.x = 310
   mario.position.y = 0
   mario.onfloor = True
   End If
End Sub

Public Sub Marioset()
    Dim htempDC As Long
    Dim hOldBmp As Long
    Dim Bmtemp As BITMAP
    'Ititialize Mario's Movement
    mario.position.x = 200
    mario.position.y = 300
    mario.speed.x = 0
    mario.speed.y = 0
    mario.startspeed.x = 20
    mario.startspeed.y = 30
    mario.onfloor = True
    mario.state = Normal
    
    mario.lives = 5
    ' Initialize Mario's Picture
    htempDC = GetDC(0)
     Set mario.picsource = New StdPicture
    Set mario.picsource = LoadPicture(App.Path & "\haloanimationstrip.bmp")
    mario.hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(mario.hsourceDC, mario.picsource.Handle)
    
    Set mario.picmask = New StdPicture
    Set mario.picmask = LoadPicture(App.Path & "\haloanimationstripmask.bmp")
    mario.hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(mario.hmaskDc, mario.picmask.Handle)
     mario.CellTop = 0
     mario.CellCount = 14
     GetObject mario.picsource.Handle, Len(Bmtemp), Bmtemp
     mario.CellWidth = Bmtemp.bmWidth
     mario.CellHeight = Bmtemp.bmHeight / mario.CellCount
    ReleaseDC 0, htempDC
       mario.radius = (mario.CellHeight + mario.CellWidth) / 4
    
End Sub

Public Sub Mariodraw()
    Dim MarioTop As Long
    Dim MarioLeft As Long
    Dim Marioacross As Long
    Dim Mariodown As Long
    MarioTop = mario.position.y
    MarioLeft = mario.position.x
    Marioacross = mario.CellWidth
    Mariodown = mario.CellHeight
    BitBlt offscreenDC, MarioLeft, MarioTop, Marioacross, Mariodown, mario.hmaskDc, 0, mario.CellTop, vbSrcAnd
    BitBlt offscreenDC, MarioLeft, MarioTop, Marioacross, Mariodown, mario.hsourceDC, 0, mario.CellTop, vbSrcPaint
End Sub


Public Function MarioAnimate()
    Dim MarioTop As Long

    MarioTop = mario.CellTop + mario.CellHeight
    If mario.speed.x > 0 Then
        If mario.onfloor = False Then
            MarioTop = 272
        Else
            If MarioTop >= 102 Then
                MarioTop = 0
            End If
        End If
    Else
        If mario.speed.x < 0 Then
            If mario.onfloor = False Then
                MarioTop = 306
            Else
                If MarioTop >= 204 Or MarioTop < 102 Then
                    MarioTop = 102
                End If
            End If
        Else
            If Int(Rnd * 30) = 0 Then
                MarioTop = 238
            Else
                MarioTop = 204
            End If
        End If
    End If
    MarioAnimate = MarioTop
End Function


Private Sub getspeed(MasterChief As sprite)
'This is checking where Mariolands'
    Dim masterchieftop As Long
    Dim masterchiefleft As Long
    Dim masterchiefright As Long
    Dim StepUp As Integer
    Dim index As Integer
    Dim StepDown As Integer
    Dim masterchiefbottom As Integer
    MasterChief.speed.y = MasterChief.speed.y + gravity
    masterchiefright = MasterChief.position.x + MasterChief.CellWidth
    masterchiefleft = MasterChief.position.x
    masterchiefbottom = MasterChief.position.y + MasterChief.CellHeight
    masterchieftop = MasterChief.position.y
    StepUp = masterchieftop + MasterChief.speed.y
    StepDown = masterchiefbottom + MasterChief.speed.y
      If MasterChief.state <> Dying Then
    If MasterChief.state = Dead Then
    If MasterChief.position.y > 19 Then
    MasterChief.speed.y = 0
    MasterChief.speed.x = 0
    Else
    MasterChief.speed.y = 5
    MasterChief.speed.x = 0
    End If
    Else
     MasterChief.onfloor = False
    For index = 0 To Floormax
        If masterchiefleft < floors(index).right And masterchiefright > floors(index).left Then
            If (masterchieftop >= floors(index).Roof And StepUp < floors(index).Roof) Or (StepDown > floors(index).top And masterchiefbottom <= floors(index).top) Then
                If (MasterChief.speed.y > 0) Then
                    MasterChief.speed.y = floors(index).top - masterchiefbottom
                    MasterChief.onfloor = True
                Else
                If Floormode = False Then
                MasterChief.speed.y = floors(index).Roof - MasterChief.position.y
                End If
                End If
            End If
        End If
        
    Next index
    End If
    End If
End Sub

Public Sub EnemySet(newSpeed As Integer)
    Dim htempDC As Long
    Dim hOldBmp As Long
    Dim Bmtemp As BITMAP
    
    EnemyAlive = bgmax
    bgnumber = 0
    bgticker = 30
    TempBgSpeed = newSpeed
    
    ' Initialize bg's Picture
    htempDC = GetDC(0)
    
    'Ititialize bg's Movement
    Enemy(0).position.x = 0
    Enemy(0).position.y = 20
    Enemy(0).speed.x = newSpeed
    Enemy(0).speed.y = 2
    Enemy(0).startspeed.x = newSpeed
    Enemy(0).startspeed.y = 35
    Enemy(0).onfloor = True
    
    Set Enemy(0).picsource = New StdPicture
    Set Enemy(0).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(0).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(0).hsourceDC, Enemy(0).picsource.Handle)
    
    Set Enemy(0).picmask = New StdPicture
    Set Enemy(0).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(0).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(0).hmaskDc, Enemy(0).picmask.Handle)
    
    Enemy(0).CellTop = 0
    Enemy(0).CellCount = 24
    GetObject Enemy(0).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(0).CellWidth = Bmtemp.bmWidth
    Enemy(0).CellHeight = Bmtemp.bmHeight / Enemy(0).CellCount
    Enemy(0).radius = (Enemy(0).CellHeight + Enemy(0).CellWidth) / 4
    Enemy(0).state = Waiting
     
    'Ititialize bg's Movement
    Enemy(1).position.x = 630
    Enemy(1).position.y = 20
    Enemy(1).speed.x = -newSpeed
    Enemy(1).speed.y = 2
    Enemy(1).startspeed.x = newSpeed
    Enemy(1).startspeed.y = 35
    Enemy(1).onfloor = True
    
    Set Enemy(1).picsource = New StdPicture
    Set Enemy(1).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(1).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(1).hsourceDC, Enemy(1).picsource.Handle)
    
    Set Enemy(1).picmask = New StdPicture
    Set Enemy(1).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(1).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(1).hmaskDc, Enemy(1).picmask.Handle)
    Enemy(1).CellTop = 0
    Enemy(1).CellCount = 24
    GetObject Enemy(1).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(1).CellWidth = Bmtemp.bmWidth
    Enemy(1).CellHeight = Bmtemp.bmHeight / Enemy(1).CellCount
    Enemy(1).radius = (Enemy(1).CellHeight + Enemy(1).CellWidth) / 4
    Enemy(1).state = Waiting
     
    'Ititialize bg's Movement
    Enemy(2).position.x = 0
    Enemy(2).position.y = 20
    Enemy(2).speed.x = newSpeed
    Enemy(2).speed.y = 2
    Enemy(2).startspeed.x = newSpeed
    Enemy(2).startspeed.y = 35
    Enemy(2).onfloor = True
    
    Set Enemy(2).picsource = New StdPicture
    Set Enemy(2).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(2).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(2).hsourceDC, Enemy(2).picsource.Handle)
    
    Set Enemy(2).picmask = New StdPicture
    Set Enemy(2).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(2).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(2).hmaskDc, Enemy(2).picmask.Handle)
    Enemy(2).CellTop = 0
    Enemy(2).CellCount = 24
    GetObject Enemy(2).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(2).CellWidth = Bmtemp.bmWidth
    Enemy(2).CellHeight = Bmtemp.bmHeight / Enemy(2).CellCount
    Enemy(2).radius = (Enemy(2).CellHeight + Enemy(2).CellWidth) / 4
    Enemy(2).state = Waiting
     
    'Ititialize bg's Movement
    Enemy(3).position.x = 630
    Enemy(3).position.y = 20
    Enemy(3).speed.x = -newSpeed
    Enemy(3).speed.y = 2
    Enemy(3).startspeed.x = newSpeed
    Enemy(3).startspeed.y = 35
    Enemy(3).onfloor = True
    
    Set Enemy(3).picsource = New StdPicture
    Set Enemy(3).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(3).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(3).hsourceDC, Enemy(3).picsource.Handle)
    
    Set Enemy(3).picmask = New StdPicture
    Set Enemy(3).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(3).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(3).hmaskDc, Enemy(3).picmask.Handle)
    Enemy(3).CellTop = 0
    Enemy(3).CellCount = 24
    GetObject Enemy(3).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(3).CellWidth = Bmtemp.bmWidth
    Enemy(3).CellHeight = Bmtemp.bmHeight / Enemy(3).CellCount
    Enemy(3).radius = (Enemy(3).CellHeight + Enemy(3).CellWidth) / 4
    Enemy(3).state = Waiting
     
     'Intitialize bg's Movement
    Enemy(4).position.x = 0
    Enemy(4).position.y = 20
    Enemy(4).speed.x = newSpeed
    Enemy(4).speed.y = 2
    Enemy(4).startspeed.x = newSpeed
    Enemy(4).startspeed.y = 35
    Enemy(4).onfloor = True
    
    Set Enemy(4).picsource = New StdPicture
    Set Enemy(4).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(4).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(4).hsourceDC, Enemy(4).picsource.Handle)
    
    Set Enemy(4).picmask = New StdPicture
    Set Enemy(4).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(4).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(4).hmaskDc, Enemy(4).picmask.Handle)
    Enemy(4).CellTop = 0
    Enemy(4).CellCount = 24
    GetObject Enemy(4).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(4).CellWidth = Bmtemp.bmWidth
    Enemy(4).CellHeight = Bmtemp.bmHeight / Enemy(4).CellCount
    Enemy(4).radius = (Enemy(4).CellHeight + Enemy(4).CellWidth) / 4
    Enemy(4).state = Waiting
    
    'Ititialize bg's Movement
    Enemy(5).position.x = 630
    Enemy(5).position.y = 20
    Enemy(5).speed.x = -newSpeed
    Enemy(5).speed.y = 2
    Enemy(5).startspeed.x = newSpeed
    Enemy(5).startspeed.y = 35
    Enemy(5).onfloor = True
    
    Set Enemy(5).picsource = New StdPicture
    Set Enemy(5).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(5).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(5).hsourceDC, Enemy(5).picsource.Handle)
    
    Set Enemy(5).picmask = New StdPicture
    Set Enemy(5).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(5).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(5).hmaskDc, Enemy(5).picmask.Handle)
    Enemy(5).CellTop = 0
    Enemy(5).CellCount = 24
    GetObject Enemy(5).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(5).CellWidth = Bmtemp.bmWidth
    Enemy(5).CellHeight = Bmtemp.bmHeight / Enemy(5).CellCount
    Enemy(5).radius = (Enemy(5).CellHeight + Enemy(5).CellWidth) / 4
    Enemy(5).state = Waiting
    
    'Ititialize bg's Movement
    Enemy(6).position.x = 0
    Enemy(6).position.y = 20
    Enemy(6).speed.x = newSpeed
    Enemy(6).speed.y = 2
    Enemy(6).startspeed.x = newSpeed
    Enemy(6).startspeed.y = 35
    Enemy(6).onfloor = True
    
    Set Enemy(6).picsource = New StdPicture
    Set Enemy(6).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(6).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(6).hsourceDC, Enemy(6).picsource.Handle)
    
    Set Enemy(6).picmask = New StdPicture
    Set Enemy(6).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(6).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(6).hmaskDc, Enemy(6).picmask.Handle)
    Enemy(6).CellTop = 0
    Enemy(6).CellCount = 24
    GetObject Enemy(6).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(6).CellWidth = Bmtemp.bmWidth
    Enemy(6).CellHeight = Bmtemp.bmHeight / Enemy(6).CellCount
    Enemy(6).radius = (Enemy(6).CellHeight + Enemy(6).CellWidth) / 4
    Enemy(6).state = Waiting
     
    'Ititialize bg's Movement
    Enemy(7).position.x = 630
    Enemy(7).position.y = 20
    Enemy(7).speed.x = -newSpeed
    Enemy(7).speed.y = 2
    Enemy(7).startspeed.x = newSpeed
    Enemy(7).startspeed.y = 35
    Enemy(7).onfloor = True
    
    Set Enemy(7).picsource = New StdPicture
    Set Enemy(7).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(7).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(7).hsourceDC, Enemy(7).picsource.Handle)
    
    Set Enemy(7).picmask = New StdPicture
    Set Enemy(7).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(7).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(7).hmaskDc, Enemy(7).picmask.Handle)
    Enemy(7).CellTop = 0
    Enemy(7).CellCount = 24
    GetObject Enemy(7).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(7).CellWidth = Bmtemp.bmWidth
    Enemy(7).CellHeight = Bmtemp.bmHeight / Enemy(7).CellCount
    Enemy(7).radius = (Enemy(7).CellHeight + Enemy(7).CellWidth) / 4
    Enemy(7).state = Waiting
     
    'Ititialize bg's Movement
    Enemy(8).position.x = 0
    Enemy(8).position.y = 20
    Enemy(8).speed.x = newSpeed
    Enemy(8).speed.y = 2
    Enemy(8).startspeed.x = newSpeed
    Enemy(8).startspeed.y = 35
    Enemy(8).onfloor = True
    
    Set Enemy(8).picsource = New StdPicture
    Set Enemy(8).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(8).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(8).hsourceDC, Enemy(8).picsource.Handle)
    
    Set Enemy(8).picmask = New StdPicture
    Set Enemy(8).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(8).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(8).hmaskDc, Enemy(8).picmask.Handle)
    Enemy(8).CellTop = 0
    Enemy(8).CellCount = 24
    GetObject Enemy(8).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(8).CellWidth = Bmtemp.bmWidth
    Enemy(8).CellHeight = Bmtemp.bmHeight / Enemy(8).CellCount
    Enemy(8).radius = (Enemy(8).CellHeight + Enemy(8).CellWidth) / 4
    Enemy(8).state = Waiting
     
    'Ititialize bg's Movement
    Enemy(9).position.x = 630
    Enemy(9).position.y = 20
    Enemy(9).speed.x = -newSpeed
    Enemy(9).speed.y = 2
    Enemy(9).startspeed.x = newSpeed
    Enemy(9).startspeed.y = 35
    Enemy(9).onfloor = True
    
    Set Enemy(9).picsource = New StdPicture
    Set Enemy(9).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(9).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(9).hsourceDC, Enemy(9).picsource.Handle)
    
    Set Enemy(9).picmask = New StdPicture
    Set Enemy(9).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(9).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(9).hmaskDc, Enemy(9).picmask.Handle)
    Enemy(9).CellTop = 0
    Enemy(9).CellCount = 24
    GetObject Enemy(9).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(9).CellWidth = Bmtemp.bmWidth
    Enemy(9).CellHeight = Bmtemp.bmHeight / Enemy(9).CellCount
    Enemy(9).radius = (Enemy(9).CellHeight + Enemy(9).CellWidth) / 4
    Enemy(9).state = Waiting
    
    'Ititialize bg's Movement
    Enemy(10).position.x = 0
    Enemy(10).position.y = 20
    Enemy(10).speed.x = newSpeed
    Enemy(10).speed.y = 2
    Enemy(10).startspeed.x = newSpeed
    Enemy(10).startspeed.y = 35
    Enemy(10).onfloor = True
    
    Set Enemy(10).picsource = New StdPicture
    Set Enemy(10).picsource = LoadPicture(App.Path & "\TurtsTR.bmp")
    Enemy(10).hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(10).hsourceDC, Enemy(10).picsource.Handle)
    
    Set Enemy(10).picmask = New StdPicture
    Set Enemy(10).picmask = LoadPicture(App.Path & "\turtsmsk.bmp")
    Enemy(10).hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Enemy(10).hmaskDc, Enemy(10).picmask.Handle)
    Enemy(10).CellTop = 0
    Enemy(10).CellCount = 24
    GetObject Enemy(10).picsource.Handle, Len(Bmtemp), Bmtemp
    Enemy(10).CellWidth = Bmtemp.bmWidth
    Enemy(10).CellHeight = Bmtemp.bmHeight / Enemy(10).CellCount
    Enemy(10).radius = (Enemy(10).CellHeight + Enemy(10).CellWidth) / 4
    Enemy(10).state = Waiting
     
    ReleaseDC 0, htempDC
End Sub

Public Sub EnemyDraw(Bg As sprite)
    Dim bgtop As Long
    Dim bgleft As Long
    Dim bgacross As Long
    Dim bgdown As Long
    bgtop = Bg.position.y
    bgleft = Bg.position.x
    bgacross = Bg.CellWidth
    bgdown = Bg.CellHeight
    BitBlt offscreenDC, bgleft, bgtop, bgacross, bgdown, Bg.hmaskDc, 0, Bg.CellTop, vbSrcAnd
    BitBlt offscreenDC, bgleft, bgtop, bgacross, bgdown, Bg.hsourceDC, 0, Bg.CellTop, vbSrcPaint
    
End Sub

Public Sub enemymove(Bg As sprite)
    getspeed Bg
   Dim EnemyBottom As Integer
   EnemyBottom = Bg.position.y + Bg.CellHeight
'If enemy is moving past the rightside
    If Bg.position.x > backdrop.Rightside Then
        If EnemyBottom = floors(0).top Then
            Bg.speed.x = -Bg.speed.x
            Bg.position.y = 10
        Else
            Bg.position.x = backdrop.Leftside
        End If
    'If enemy is moving past the leftside
    Else
        If Bg.position.x < backdrop.Leftside Then
            If EnemyBottom = floors(0).top Then
                Bg.speed.x = -Bg.speed.x
                Bg.position.y = 10
            Else
                Bg.position.x = backdrop.Rightside
            End If
        Else
            Bg.position.x = Bg.position.x + Bg.speed.x
            
        End If
    End If
           Bg.position.y = Bg.position.y + Bg.speed.y
           If Bg.position.y > 480 Then
           Bg.state = Dead
           EnemyAlive = EnemyAlive - 1
           If EnemyAlive < 0 Then
                EnemySet (TempBgSpeed + 2)
                Level.Show vbModal
           
           End If
           End If
           
End Sub

Public Function EnemyAnimate(Enemy As sprite)
    Dim enemytop As Long

    enemytop = Enemy.CellTop + Enemy.CellHeight
    Select Case Enemy.state
        Case Normal
            If Enemy.speed.x > 0 Then
                    If enemytop > 36 Then
                        enemytop = 0
                    End If
               
            Else
                If Enemy.speed.x < 0 Then
                    If enemytop > 108 Or enemytop < 36 Then
                        enemytop = 72
                    End If
                 
                End If
            End If
        Case Flipped
            If Enemy.speed.y <> 0 Then
                If enemytop > 324 Or enemytop < 288 Then
                    enemytop = 288
                End If
            Else
                    If enemytop > 180 Then
                    enemytop = 144
            End If
            End If
        Case Dying
         If enemytop > 324 Or enemytop < 288 Then
                    enemytop = 288
                End If
            
    End Select
    EnemyAnimate = enemytop
    If Enemy.position.y > 480 Then
    Enemy.state = Dead
    End If
    End Function



Public Function Collide(Mradius As Long, mcenter As point, ERadius As Long, ECenter As point)
Dim A As Long
Dim B As Long
Dim C As Long
A = mcenter.x - ECenter.x
B = mcenter.y - ECenter.y
C = Sqr(A * A + B * B)
If C < Mradius + ERadius Then
Collide = True
Else
Collide = False
End If
End Function

Public Sub EnemyCollided(Bg As sprite)
    Dim Bump As Boolean
    Dim index As Integer
    Dim MarioRight As Integer
    Dim EnemyBottom As Integer
    Dim MarioTop As Integer
    Dim MarioLeft As Integer
   
    Bump = False
    index = 0
    MarioRight = mario.position.x + mario.CellWidth
    MarioLeft = mario.position.x
    MarioTop = mario.position.y
    EnemyBottom = Bg.position.y + Bg.CellHeight
    
    Do While index <= Floormax
        If MarioTop >= floors(index).Roof And EnemyBottom <= floors(index).top Then
            If MarioRight > floors(index).left And MarioLeft < floors(index).right Then
                Bump = True
            End If
        End If
        index = index + 1
    Loop
    
    If Bump = True Then
        Bg.speed.x = 2 * Int(Rnd * 5)
        Bg.state = Flipped
        Bg.speed.y = -Bg.startspeed.y
    Else
        If Bg.state = Normal Then
            If invincible = False Then
                mario.lives = mario.lives - 1
                If mario.lives <= 0 Then
                GameOver.Show vbModal
                Marioset
                EnemySet 5
                Else
                mario.state = Dying
                End If
                'Death.Show vbModal
                'mario.position.x = 300
                'mario.speed.y = 0'
                'mario.speed.x = 0
            End If
            
        Else
            If Bg.state = Flipped Then
                Bg.state = Dying
                Bg.speed.x = mario.speed.x * Int(Rnd * 2.5)
                Bg.speed.y = -Bg.startspeed.y * Int(Rnd * 2.5)
                Scorenum = Scorenum + Points
            Else
              If Bg.state = Dying Then
              Bg.speed.x = mario.speed.x * Int(Rnd * 2.5)
              Bg.speed.y = -Bg.startspeed.y * Int(Rnd * 2.5)
                Scorenum = Scorenum + Points
              End If
            End If
         End If
    End If
End Sub

Public Sub EnemyCreate()
    bgticker = bgticker - 1
    If bgticker = 0 And bgnumber <= bgmax Then
        Enemy(bgnumber).state = Normal
        bgticker = 30
        bgnumber = bgnumber + 1
    End If
End Sub
